Index: issm/trunk/src/c/classes/gauss/GaussPenta.cpp
===================================================================
--- issm/trunk/src/c/classes/gauss/GaussPenta.cpp	(revision 18081)
+++ issm/trunk/src/c/classes/gauss/GaussPenta.cpp	(revision 18301)
@@ -13,6 +13,5 @@
 
 /*GaussPenta constructors and destructors:*/
-/*FUNCTION GaussPenta::GaussPenta() {{{*/
-GaussPenta::GaussPenta(){
+GaussPenta::GaussPenta(){/*{{{*/
 
 	numgauss=-1;
@@ -31,6 +30,5 @@
 }
 /*}}}*/
-/*FUNCTION GaussPenta::GaussPenta(int order_horiz,int order_vert) {{{*/
-GaussPenta::GaussPenta(int order_horiz,int order_vert){
+GaussPenta::GaussPenta(int order_horiz,int order_vert){/*{{{*/
 
 	/*Intermediaries*/
@@ -85,6 +83,5 @@
 }
 /*}}}*/
-/*FUNCTION GaussPenta::GaussPenta(int index1, int index2, int order){{{*/
-GaussPenta::GaussPenta(int index1, int index2,int order){
+GaussPenta::GaussPenta(int index1, int index2,int order){/*{{{*/
 
 	/*Intermediaties*/
@@ -142,6 +139,5 @@
 }
 /*}}}*/
-/*FUNCTION GaussPenta::GaussPenta(int index1, int index2, int index3, int order){{{*/
-GaussPenta::GaussPenta(int index1, int index2, int index3, int order){
+GaussPenta::GaussPenta(int index1, int index2, int index3, int order){/*{{{*/
 
 	/*Basal Tria*/
@@ -171,6 +167,5 @@
 }
 /*}}}*/
-/*FUNCTION GaussPenta::GaussPenta(int index1, int index2, int index3, int index4,int order_horiz,int order_vert){{{*/
-GaussPenta::GaussPenta(int index1, int index2, int index3, int index4,int order_horiz,int order_vert){
+GaussPenta::GaussPenta(int index1, int index2, int index3, int index4,int order_horiz,int order_vert){/*{{{*/
 
 	/*Intermediaties*/
@@ -238,6 +233,5 @@
 }
 /*}}}*/
-/*FUNCTION GaussPenta::GaussPenta(int index,double r1,double r2,int order) {{{*/
-GaussPenta::GaussPenta(int index,IssmDouble r1,IssmDouble r2,bool mainlyfloating,int order){
+GaussPenta::GaussPenta(int index,IssmDouble r1,IssmDouble r2,bool mainlyfloating,int order){/*{{{*/
 
 	/*
@@ -400,6 +394,5 @@
 }
 /*}}}*/
-/*FUNCTION GaussPenta::GaussPenta(IssmDouble area_coordinates[4][3],int order_horiz,int order_vert){{{*/
-GaussPenta::GaussPenta(IssmDouble area_coordinates[4][3],int order_horiz,int order_vert){
+GaussPenta::GaussPenta(IssmDouble area_coordinates[4][3],int order_horiz,int order_vert){/*{{{*/
 
 	/*Intermediaties*/
@@ -439,6 +432,5 @@
 }
 /*}}}*/
-/*FUNCTION GaussPenta::~GaussPenta(){{{*/
-GaussPenta::~GaussPenta(){
+GaussPenta::~GaussPenta(){/*{{{*/
 	xDelete<IssmDouble>(weights);
 	xDelete<IssmDouble>(coords1);
@@ -450,6 +442,5 @@
 
 /*Methods*/
-/*FUNCTION GaussPenta::Echo{{{*/
-void GaussPenta::Echo(void){
+void GaussPenta::Echo(void){/*{{{*/
 
 	_printf_("GaussPenta:\n");
@@ -495,11 +486,9 @@
 }
 /*}}}*/
-/*FUNCTION GaussPenta::Enum{{{*/
-int GaussPenta::Enum(void){
+int GaussPenta::Enum(void){/*{{{*/
 	return GaussPentaEnum;
 }
 /*}}}*/
-/*FUNCTION GaussPenta::GaussPoint{{{*/
-void GaussPenta::GaussPoint(int ig){
+void GaussPenta::GaussPoint(int ig){/*{{{*/
 
 	/*Check input in debugging mode*/
@@ -515,6 +504,5 @@
 }
 /*}}}*/
-/*FUNCTION GaussPenta::GaussVertex{{{*/
-void GaussPenta::GaussVertex(int iv){
+void GaussPenta::GaussVertex(int iv){/*{{{*/
 
 	/*in debugging mode: check that the default constructor has been called*/
@@ -535,6 +523,5 @@
 }
 /*}}}*/
-/*FUNCTION GaussPenta::GaussFaceTria{{{*/
-void GaussPenta::GaussFaceTria(int index1, int index2, int index3, int order){
+void GaussPenta::GaussFaceTria(int index1, int index2, int index3, int order){/*{{{*/
 
 	/*in debugging mode: check that the default constructor has been called*/
@@ -553,6 +540,5 @@
 }
 /*}}}*/
-/*FUNCTION GaussPenta::GaussNode{{{*/
-void GaussPenta::GaussNode(int finiteelement,int iv){
+void GaussPenta::GaussNode(int finiteelement,int iv){/*{{{*/
 
 	/*in debugging mode: check that the default constructor has been called*/
@@ -661,4 +647,32 @@
 			}
 			break;
+		case P2bubbleEnum: case P2bubblecondensedEnum:
+			switch(iv){
+				case 0: coord1=1.; coord2=0.; coord3=0.; coord4=-1.; break;
+				case 1: coord1=0.; coord2=1.; coord3=0.; coord4=-1.; break;
+				case 2: coord1=0.; coord2=0.; coord3=1.; coord4=-1.; break;
+				case 3: coord1=1.; coord2=0.; coord3=0.; coord4=+1.; break;
+				case 4: coord1=0.; coord2=1.; coord3=0.; coord4=+1.; break;
+				case 5: coord1=0.; coord2=0.; coord3=1.; coord4=+1.; break;
+
+				case 6: coord1=1.; coord2=0.; coord3=0.; coord4=0.; break;
+				case 7: coord1=0.; coord2=1.; coord3=0.; coord4=0.; break;
+				case 8: coord1=0.; coord2=0.; coord3=1.; coord4=0.; break;
+
+				case  9: coord1=0.; coord2=.5; coord3=.5; coord4=-1.;break;
+				case 10: coord1=.5; coord2=0.; coord3=.5; coord4=-1.;break;
+				case 11: coord1=.5; coord2=.5; coord3=0.; coord4=-1.;break;
+				case 12: coord1=0.; coord2=.5; coord3=.5; coord4=+1.;break;
+				case 13: coord1=.5; coord2=0.; coord3=.5; coord4=+1.;break;
+				case 14: coord1=.5; coord2=.5; coord3=0.; coord4=+1.;break;
+
+				case 15: coord1=0.; coord2=.5; coord3=.5; coord4=0.;break;
+				case 16: coord1=.5; coord2=0.; coord3=.5; coord4=0.;break;
+				case 17: coord1=.5; coord2=.5; coord3=0.; coord4=0.;break;
+
+				case 18: coord1=1./3.; coord2=1./3.; coord3=1./3.; coord4=0.;  break;
+				default: _error_("node index should be in [0 18]");
+			}
+			break;
 		case P2xP4Enum:
 			switch(iv){
@@ -705,6 +719,5 @@
 }
 /*}}}*/
-/*FUNCTION GaussPenta::begin{{{*/
-int GaussPenta::begin(void){
+int GaussPenta::begin(void){/*{{{*/
 
 	/*Check that this has been initialized*/
@@ -720,6 +733,5 @@
 }
 /*}}}*/
-/*FUNCTION GaussPenta::end{{{*/
-int GaussPenta::end(void){
+int GaussPenta::end(void){/*{{{*/
 
 	/*Check that this has been initialized*/
@@ -735,6 +747,5 @@
 }
 /*}}}*/
-/*FUNCTION GaussPenta::SynchronizeGaussBase{{{*/
-void GaussPenta::SynchronizeGaussBase(Gauss* gauss){
+void GaussPenta::SynchronizeGaussBase(Gauss* gauss){/*{{{*/
 
 	_assert_(gauss->Enum()==GaussTriaEnum);
Index: issm/trunk/src/c/classes/gauss/GaussSeg.cpp
===================================================================
--- issm/trunk/src/c/classes/gauss/GaussSeg.cpp	(revision 18081)
+++ issm/trunk/src/c/classes/gauss/GaussSeg.cpp	(revision 18301)
@@ -12,6 +12,5 @@
 
 /*GaussSeg constructors and destructors:*/
-/*FUNCTION GaussSeg::GaussSeg() {{{*/
-GaussSeg::GaussSeg(){
+GaussSeg::GaussSeg(){/*{{{*/
 
 	numgauss=-1;
@@ -24,6 +23,5 @@
 }
 /*}}}*/
-/*FUNCTION GaussSeg::GaussSeg(int order) {{{*/
-GaussSeg::GaussSeg(int order){
+GaussSeg::GaussSeg(int order){/*{{{*/
 
 	IssmPDouble* pcoords1=NULL;
@@ -52,6 +50,5 @@
 }
 /*}}}*/
-/*FUNCTION GaussSeg::GaussSeg(IssmDouble position) {{{*/
-GaussSeg::GaussSeg(IssmDouble position){
+GaussSeg::GaussSeg(IssmDouble position){/*{{{*/
 
 	/*Get gauss points*/
@@ -70,6 +67,5 @@
 }
 /*}}}*/
-/*FUNCTION GaussSeg::~GaussSeg(){{{*/
-GaussSeg::~GaussSeg(){
+GaussSeg::~GaussSeg(){/*{{{*/
 	xDelete<IssmDouble>(weights);
 	xDelete<IssmDouble>(coords1);
@@ -78,6 +74,5 @@
 
 /*Methods*/
-/*FUNCTION GaussSeg::Echo{{{*/
-void GaussSeg::Echo(void){
+void GaussSeg::Echo(void){/*{{{*/
 
 	_printf_("GaussSeg:\n");
@@ -100,11 +95,9 @@
 }
 /*}}}*/
-/*FUNCTION GaussSeg::Enum{{{*/
-int GaussSeg::Enum(void){
+int GaussSeg::Enum(void){/*{{{*/
 	return GaussSegEnum;
 }
 /*}}}*/
-/*FUNCTION GaussSeg::GaussPoint{{{*/
-void GaussSeg::GaussPoint(int ig){
+void GaussSeg::GaussPoint(int ig){/*{{{*/
 
 	/*Check input in debugging mode*/
@@ -116,6 +109,5 @@
 }
 /*}}}*/
-/*FUNCTION GaussSeg::GaussVertex{{{*/
-void GaussSeg::GaussVertex(int iv){
+void GaussSeg::GaussVertex(int iv){/*{{{*/
 
 	/*in debugging mode: check that the default constructor has been called*/
@@ -130,6 +122,5 @@
 }
 /*}}}*/
-/*FUNCTION GaussSeg::GaussNode{{{*/
-void GaussSeg::GaussNode(int finiteelement,int iv){
+void GaussSeg::GaussNode(int finiteelement,int iv){/*{{{*/
 
 	/*in debugging mode: check that the default constructor has been called*/
@@ -150,6 +141,5 @@
 }
 /*}}}*/
-/*FUNCTION GaussSeg::begin{{{*/
-int GaussSeg::begin(void){
+int GaussSeg::begin(void){/*{{{*/
 
 	/*Check that this has been initialized*/
@@ -162,6 +152,5 @@
 }
 /*}}}*/
-/*FUNCTION GaussSeg::end{{{*/
-int GaussSeg::end(void){
+int GaussSeg::end(void){/*{{{*/
 
 	/*Check that this has been initialized*/
@@ -174,6 +163,5 @@
 }
 /*}}}*/
-/*FUNCTION GaussSeg::SynchronizeGaussBase{{{*/
-void GaussSeg::SynchronizeGaussBase(Gauss* gauss){
+void GaussSeg::SynchronizeGaussBase(Gauss* gauss){/*{{{*/
 
 	_error_("not supported");
Index: issm/trunk/src/c/classes/gauss/GaussTetra.cpp
===================================================================
--- issm/trunk/src/c/classes/gauss/GaussTetra.cpp	(revision 18081)
+++ issm/trunk/src/c/classes/gauss/GaussTetra.cpp	(revision 18301)
@@ -13,6 +13,5 @@
 
 /*GaussTetra constructors and destructors:*/
-/*FUNCTION GaussTetra::GaussTetra() {{{*/
-GaussTetra::GaussTetra(){
+GaussTetra::GaussTetra(){/*{{{*/
 
 	numgauss=-1;
@@ -31,6 +30,5 @@
 }
 /*}}}*/
-/*FUNCTION GaussTetra::GaussTetra(int order) {{{*/
-GaussTetra::GaussTetra(int order){
+GaussTetra::GaussTetra(int order){/*{{{*/
 
 	/*Get gauss points*/
@@ -58,6 +56,5 @@
 }
 /*}}}*/
-/*FUNCTION GaussTetra::GaussTetra(int index1,int index2,int index3,int order) {{{*/
-GaussTetra::GaussTetra(int index1,int index2,int index3,int order){
+GaussTetra::GaussTetra(int index1,int index2,int index3,int order){/*{{{*/
 
 	/*Basal Tria*/
@@ -87,6 +84,5 @@
 }
 /*}}}*/
-/*FUNCTION GaussTetra::~GaussTetra(){{{*/
-GaussTetra::~GaussTetra(){
+GaussTetra::~GaussTetra(){/*{{{*/
 	xDelete<IssmDouble>(weights);
 	xDelete<IssmDouble>(coords1);
@@ -98,6 +94,5 @@
 
 /*Methods*/
-/*FUNCTION GaussTetra::Echo{{{*/
-void GaussTetra::Echo(void){
+void GaussTetra::Echo(void){/*{{{*/
 
 	_printf_("GaussTetra:\n");
@@ -143,11 +138,9 @@
 }
 /*}}}*/
-/*FUNCTION GaussTetra::Enum{{{*/
-int GaussTetra::Enum(void){
+int GaussTetra::Enum(void){/*{{{*/
 	return GaussTetraEnum;
 }
 /*}}}*/
-/*FUNCTION GaussTetra::GaussPoint{{{*/
-void GaussTetra::GaussPoint(int ig){
+void GaussTetra::GaussPoint(int ig){/*{{{*/
 
 	/*Check input in debugging mode*/
@@ -163,6 +156,5 @@
 }
 /*}}}*/
-/*FUNCTION GaussTetra::GaussVertex{{{*/
-void GaussTetra::GaussVertex(int iv){
+void GaussTetra::GaussVertex(int iv){/*{{{*/
 
 	/*in debugging mode: check that the default constructor has been called*/
@@ -181,6 +173,5 @@
 }
 /*}}}*/
-/*FUNCTION GaussTetra::GaussNode{{{*/
-void GaussTetra::GaussNode(int finiteelement,int iv){
+void GaussTetra::GaussNode(int finiteelement,int iv){/*{{{*/
 
 	/*in debugging mode: check that the default constructor has been called*/
@@ -229,6 +220,5 @@
 }
 /*}}}*/
-/*FUNCTION GaussTetra::begin{{{*/
-int GaussTetra::begin(void){
+int GaussTetra::begin(void){/*{{{*/
 
 	/*Check that this has been initialized*/
@@ -244,6 +234,5 @@
 }
 /*}}}*/
-/*FUNCTION GaussTetra::end{{{*/
-int GaussTetra::end(void){
+int GaussTetra::end(void){/*{{{*/
 
 	/*Check that this has been initialized*/
@@ -259,6 +248,5 @@
 }
 /*}}}*/
-/*FUNCTION GaussTetra::SynchronizeGaussBase{{{*/
-void GaussTetra::SynchronizeGaussBase(Gauss* gauss){
+void GaussTetra::SynchronizeGaussBase(Gauss* gauss){/*{{{*/
 
 	_error_("not supported");
Index: issm/trunk/src/c/classes/gauss/GaussTria.cpp
===================================================================
--- issm/trunk/src/c/classes/gauss/GaussTria.cpp	(revision 18081)
+++ issm/trunk/src/c/classes/gauss/GaussTria.cpp	(revision 18301)
@@ -7,6 +7,5 @@
 
 /*GaussTria constructors and destructors:*/
-/*FUNCTION GaussTria::GaussTria() {{{*/
-GaussTria::GaussTria(){
+GaussTria::GaussTria(){/*{{{*/
 
 	numgauss=-1;
@@ -23,6 +22,5 @@
 }
 /*}}}*/
-/*FUNCTION GaussTria::GaussTria(int order) {{{*/
-GaussTria::GaussTria(int order){
+GaussTria::GaussTria(int order){/*{{{*/
 
 	/*Get gauss points*/
@@ -37,6 +35,5 @@
 }
 /*}}}*/
-/*FUNCTION GaussTria::GaussTria(int index1,int index2,int order) {{{*/
-GaussTria::GaussTria(int index1,int index2,int order){
+GaussTria::GaussTria(int index1,int index2,int order){/*{{{*/
 
 	/*Intermediaties*/
@@ -100,6 +97,5 @@
 }
 /*}}}*/
-/*FUNCTION GaussTria::GaussTria(IssmDouble area_coordinates,int order) {{{*/
-GaussTria::GaussTria(IssmDouble area_coordinates[2][3],int order){
+GaussTria::GaussTria(IssmDouble area_coordinates[2][3],int order){/*{{{*/
 
 	/*Intermediaties*/
@@ -136,6 +132,5 @@
 }
 /*}}}*/
-/*FUNCTION GaussTria::GaussTria(int index,double r1,double r2,int order) {{{*/
-GaussTria::GaussTria(int index,IssmDouble r1,IssmDouble r2,bool mainlyfloating,int order){
+GaussTria::GaussTria(int index,IssmDouble r1,IssmDouble r2,bool mainlyfloating,int order){/*{{{*/
 
 	/*
@@ -292,6 +287,5 @@
 }
 /*}}}*/
-/*FUNCTION GaussTria::~GaussTria(){{{*/
-GaussTria::~GaussTria(){
+GaussTria::~GaussTria(){/*{{{*/
 	xDelete<IssmDouble>(weights);
 	xDelete<IssmDouble>(coords3);
@@ -303,6 +297,5 @@
 
 /*Methods*/
-/*FUNCTION GaussTria::Echo{{{*/
-void GaussTria::Echo(void){
+void GaussTria::Echo(void){/*{{{*/
 
 	_printf_("GaussTria:\n");
@@ -341,11 +334,9 @@
 }
 /*}}}*/
-/*FUNCTION GaussTria::Enum{{{*/
-int GaussTria::Enum(void){
+int GaussTria::Enum(void){/*{{{*/
 	return GaussTriaEnum;
 }
 /*}}}*/
-/*FUNCTION GaussTria::GaussEdgeCenter{{{*/
-void GaussTria::GaussEdgeCenter(int index1,int index2){
+void GaussTria::GaussEdgeCenter(int index1,int index2){/*{{{*/
 
 	int     index3;
@@ -377,6 +368,5 @@
 }
 /*}}}*/
-/*FUNCTION GaussTria::GaussPoint{{{*/
-void GaussTria::GaussPoint(int ig){
+void GaussTria::GaussPoint(int ig){/*{{{*/
 
 	/*Check input in debugging mode*/
@@ -391,6 +381,5 @@
 }
 /*}}}*/
-/*FUNCTION GaussTria::GaussFromCoords{{{*/
-void GaussTria::GaussFromCoords(IssmDouble x,IssmDouble y,IssmDouble* xyz_list){
+void GaussTria::GaussFromCoords(IssmDouble x,IssmDouble y,IssmDouble* xyz_list){/*{{{*/
 
 	/*Intermediaries*/
@@ -418,6 +407,5 @@
 }
 /*}}}*/
-/*FUNCTION GaussTria::GaussVertex{{{*/
-void GaussTria::GaussVertex(int iv){
+void GaussTria::GaussVertex(int iv){/*{{{*/
 
 	/*in debugging mode: check that the default constructor has been called*/
@@ -434,6 +422,5 @@
 }
 /*}}}*/
-/*FUNCTION GaussTria::GaussNode{{{*/
-void GaussTria::GaussNode(int finiteelement,int iv){
+void GaussTria::GaussNode(int finiteelement,int iv){/*{{{*/
 
 	/*in debugging mode: check that the default constructor has been called*/
@@ -442,4 +429,10 @@
 	/*update static arrays*/
 	switch(finiteelement){
+		case P0Enum:
+			switch(iv){
+				case 0: coord1=1./3.; coord2=1./3.; coord3=1./3.; break;
+				default: _error_("node index should be 0");
+			}
+			break;
 		case P1Enum: case P1DGEnum:
 			switch(iv){
@@ -470,4 +463,16 @@
 			}
 			break;
+		case P2bubbleEnum: case P2bubblecondensedEnum:
+			switch(iv){
+				case 0: coord1=1.; coord2=0.; coord3=0.; break;
+				case 1: coord1=0.; coord2=1.; coord3=0.; break;
+				case 2: coord1=0.; coord2=0.; coord3=1.; break;
+				case 3: coord1=0.; coord2=.5; coord3=.5; break;
+				case 4: coord1=.5; coord2=0.; coord3=.5; break;
+				case 5: coord1=.5; coord2=.5; coord3=0.; break;
+				case 6: coord1=1./3.; coord2=1./3.; coord3=1./3.; break;
+				default: _error_("node index should be in [0 6]");
+			}
+			break;
 		default: _error_("Finite element "<<EnumToStringx(finiteelement)<<" not supported");
 	}
@@ -475,6 +480,5 @@
 }
 /*}}}*/
-/*FUNCTION GaussTria::begin{{{*/
-int GaussTria::begin(void){
+int GaussTria::begin(void){/*{{{*/
 
 	/*Check that this has been initialized*/
@@ -489,6 +493,5 @@
 }
 /*}}}*/
-/*FUNCTION GaussTria::end{{{*/
-int GaussTria::end(void){
+int GaussTria::end(void){/*{{{*/
 
 	/*Check that this has been initialized*/
@@ -503,6 +506,5 @@
 }
 /*}}}*/
-/*FUNCTION GaussTria::SynchronizeGaussBase{{{*/
-void GaussTria::SynchronizeGaussBase(Gauss* gauss){
+void GaussTria::SynchronizeGaussBase(Gauss* gauss){/*{{{*/
 
 	_error_("not supported");
Index: issm/trunk/src/c/classes/kriging/ExponentialVariogram.cpp
===================================================================
--- issm/trunk/src/c/classes/kriging/ExponentialVariogram.cpp	(revision 18081)
+++ issm/trunk/src/c/classes/kriging/ExponentialVariogram.cpp	(revision 18301)
@@ -13,6 +13,5 @@
 
 /*ExponentialVariogram constructors and destructor*/
-/*FUNCTION ExponentialVariogram::ExponentialVariogram(){{{*/
-ExponentialVariogram::ExponentialVariogram(){
+ExponentialVariogram::ExponentialVariogram(){/*{{{*/
 	this->nugget = 0.2;
 	this->sill   = 1;
@@ -21,6 +20,5 @@
 }
 /*}}}*/
-/*FUNCTION ExponentialVariogram::ExponentialVariogram(Options* options){{{*/
-ExponentialVariogram::ExponentialVariogram(Options* options){
+ExponentialVariogram::ExponentialVariogram(Options* options){/*{{{*/
 
 	/*Defaults*/
@@ -38,6 +36,5 @@
 }
 /*}}}*/
-/*FUNCTION ExponentialVariogram::~ExponentialVariogram(){{{*/
-ExponentialVariogram::~ExponentialVariogram(){
+ExponentialVariogram::~ExponentialVariogram(){/*{{{*/
 	return;
 }
@@ -45,6 +42,5 @@
 
 /*Object virtual functions definitions:*/
-/*FUNCTION ExponentialVariogram::Echo {{{*/
-void ExponentialVariogram::Echo(void){
+void ExponentialVariogram::Echo(void){/*{{{*/
 	_printf_("ExponentialVariogram\n");
 	_printf_("   nugget: " << this->nugget << "\n");
@@ -53,8 +49,11 @@
 }
 /*}}}*/
+Object* ExponentialVariogram::copy(void){/*{{{*/
+	   return new ExponentialVariogram(*this);
+}
+/*}}}*/
 
 /*Variogram function*/
-/*FUNCTION ExponentialVariogram::Covariance{{{*/
-double ExponentialVariogram::Covariance(double deltax,double deltay){
+double ExponentialVariogram::Covariance(double deltax,double deltay){/*{{{*/
 	/*The covariance can be deduced from the variogram from the following
 	 * relationship:
@@ -76,6 +75,5 @@
 }
 /*}}}*/
-/*FUNCTION ExponentialVariogram::SemiVariogram{{{*/
-double ExponentialVariogram::SemiVariogram(double deltax,double deltay){
+double ExponentialVariogram::SemiVariogram(double deltax,double deltay){/*{{{*/
 	/*http://en.wikipedia.org/wiki/Variogram*/
 	double h,a,gamma;
Index: issm/trunk/src/c/classes/kriging/ExponentialVariogram.h
===================================================================
--- issm/trunk/src/c/classes/kriging/ExponentialVariogram.h	(revision 18081)
+++ issm/trunk/src/c/classes/kriging/ExponentialVariogram.h	(revision 18301)
@@ -26,5 +26,5 @@
 		int   Id(){_error_("Not implemented yet");}; 
 		int   ObjectEnum(){_error_("Not implemented yet");};
-		Object* copy(){_error_("Not implemented yet");};
+		Object* copy();
 
 		/*Variogram functions*/
Index: issm/trunk/src/c/classes/kriging/GaussianVariogram.cpp
===================================================================
--- issm/trunk/src/c/classes/kriging/GaussianVariogram.cpp	(revision 18081)
+++ issm/trunk/src/c/classes/kriging/GaussianVariogram.cpp	(revision 18301)
@@ -13,6 +13,5 @@
 
 /*GaussianVariogram constructors and destructor*/
-/*FUNCTION GaussianVariogram::GaussianVariogram(){{{*/
-GaussianVariogram::GaussianVariogram(){
+GaussianVariogram::GaussianVariogram(){/*{{{*/
 	this->nugget = 0.2;
 	this->sill   = 1;
@@ -21,6 +20,5 @@
 }
 /*}}}*/
-/*FUNCTION GaussianVariogram::GaussianVariogram(Options* options){{{*/
-GaussianVariogram::GaussianVariogram(Options* options){
+GaussianVariogram::GaussianVariogram(Options* options){/*{{{*/
 
 	/*Defaults*/
@@ -38,6 +36,5 @@
 }
 /*}}}*/
-/*FUNCTION GaussianVariogram::~GaussianVariogram(){{{*/
-GaussianVariogram::~GaussianVariogram(){
+GaussianVariogram::~GaussianVariogram(){/*{{{*/
 	return;
 }
@@ -45,6 +42,5 @@
 
 /*Object virtual functions definitions:*/
-/*FUNCTION GaussianVariogram::Echo {{{*/
-void GaussianVariogram::Echo(void){
+void GaussianVariogram::Echo(void){/*{{{*/
 	_printf_("GaussianVariogram\n");
 	_printf_("   nugget: " << this->nugget << "\n");
@@ -53,8 +49,11 @@
 }
 /*}}}*/
+Object* GaussianVariogram::copy(void){/*{{{*/
+	   return new GaussianVariogram(*this);
+}
+/*}}}*/
 
 /*Variogram function*/
-/*FUNCTION GaussianVariogram::Covariance{{{*/
-double GaussianVariogram::Covariance(double deltax,double deltay){
+double GaussianVariogram::Covariance(double deltax,double deltay){/*{{{*/
 	/*The covariance can be deduced from the variogram from the following
 	 * relationship:
@@ -77,6 +76,5 @@
 }
 /*}}}*/
-/*FUNCTION GaussianVariogram::SemiVariogram{{{*/
-double GaussianVariogram::SemiVariogram(double deltax,double deltay){
+double GaussianVariogram::SemiVariogram(double deltax,double deltay){/*{{{*/
 	/*http://en.wikipedia.org/wiki/Variogram*/
 	double h2,a,gamma;
Index: issm/trunk/src/c/classes/kriging/GaussianVariogram.h
===================================================================
--- issm/trunk/src/c/classes/kriging/GaussianVariogram.h	(revision 18081)
+++ issm/trunk/src/c/classes/kriging/GaussianVariogram.h	(revision 18301)
@@ -27,5 +27,5 @@
 		int   Id(){_error_("Not implemented yet");}; 
 		int   ObjectEnum(){_error_("Not implemented yet");};
-		Object* copy(){_error_("Not implemented yet");};
+		Object* copy();
 
 		/*Variogram functions*/
Index: issm/trunk/src/c/classes/kriging/Observation.cpp
===================================================================
--- issm/trunk/src/c/classes/kriging/Observation.cpp	(revision 18081)
+++ issm/trunk/src/c/classes/kriging/Observation.cpp	(revision 18301)
@@ -7,11 +7,9 @@
 
 /*Observation constructors and destructor*/
-/*FUNCTION Observation::Observation(){{{*/
-Observation::Observation(){
+Observation::Observation(){/*{{{*/
 	return;
 }
 /*}}}*/
-/*FUNCTION Observation::Observation(double x,double y,int xi,int yi,int index,double value){{{*/
-Observation::Observation(double x_in,double y_in,int xi_in,int yi_in,int index_in,double value_in){
+Observation::Observation(double x_in,double y_in,int xi_in,int yi_in,int index_in,double value_in){/*{{{*/
 
 	this->x      = x_in;
@@ -25,6 +23,5 @@
 }
 /*}}}*/
-/*FUNCTION Observation::~Observation(){{{*/
-Observation::~Observation(){
+Observation::~Observation(){/*{{{*/
 	return;
 }
@@ -32,6 +29,5 @@
 
 /*Object virtual functions definitions:*/
-/*FUNCTION Observation::Echo {{{*/
-void Observation::Echo(void){
+void Observation::Echo(void){/*{{{*/
 
 	_printf_("Observation\n");
@@ -45,8 +41,17 @@
 }
 /*}}}*/
+Object* Observation::copy(void){/*{{{*/
+
+	Observation* observation = new Observation(this->x,this->y,this->xi,this->yi,this->index,this->value);
+
+	observation->weight = this->weight;
+
+	return (Object*) observation;
+
+}
+/*}}}*/
 
 /*Observations functions*/
-/*FUNCTION Observation::WriteXYObs(double* px,double* py,double* pobs){{{*/
-void Observation::WriteXYObs(double* px,double* py,double* pobs){
+void Observation::WriteXYObs(double* px,double* py,double* pobs){/*{{{*/
 	*px   = this->x;
 	*py   = this->y;
Index: issm/trunk/src/c/classes/kriging/Observation.h
===================================================================
--- issm/trunk/src/c/classes/kriging/Observation.h	(revision 18081)
+++ issm/trunk/src/c/classes/kriging/Observation.h	(revision 18301)
@@ -27,5 +27,5 @@
 		int     Id()        {_error_("Not implemented yet"); };
 		int     ObjectEnum(){_error_("Not implemented yet"); };
-		Object *copy()      {_error_("Not implemented yet"); };
+		Object *copy();
 
 		/*Management*/
Index: issm/trunk/src/c/classes/kriging/Observations.cpp
===================================================================
--- issm/trunk/src/c/classes/kriging/Observations.cpp	(revision 18081)
+++ issm/trunk/src/c/classes/kriging/Observations.cpp	(revision 18301)
@@ -30,12 +30,10 @@
 
 /*Object constructors and destructor*/
-/*FUNCTION Observations::Observations(){{{*/
-Observations::Observations(){
+Observations::Observations(){/*{{{*/
 	this->quadtree = NULL;
 	return;
 }
 /*}}}*/
-/*FUNCTION Observations::Observations(IssmPDouble* observations_list,IssmPDouble* x,IssmPDouble* y,int n,Options* options){{{*/
-Observations::Observations(IssmPDouble* observations_list,IssmPDouble* x,IssmPDouble* y,int n,Options* options){
+Observations::Observations(IssmPDouble* observations_list,IssmPDouble* x,IssmPDouble* y,int n,Options* options){/*{{{*/
 
 	/*Intermediaries*/
@@ -112,6 +110,5 @@
 }
 /*}}}*/
-/*FUNCTION Observations::~Observations(){{{*/
-Observations::~Observations(){
+Observations::~Observations(){/*{{{*/
 	delete quadtree;
 	return;
@@ -120,6 +117,5 @@
 
 /*Methods*/
-/*FUNCTION Observations::ClosestObservation{{{*/
-void Observations::ClosestObservation(IssmPDouble *px,IssmPDouble *py,IssmPDouble *pobs,IssmPDouble x_interp,IssmPDouble y_interp,IssmPDouble radius){
+void Observations::ClosestObservation(IssmPDouble *px,IssmPDouble *py,IssmPDouble *pobs,IssmPDouble x_interp,IssmPDouble y_interp,IssmPDouble radius){/*{{{*/
 
 	/*Output and Intermediaries*/
@@ -172,6 +168,5 @@
 
 }/*}}}*/
-/*FUNCTION Observations::Distances{{{*/
-void Observations::Distances(IssmPDouble* distances,IssmPDouble *x,IssmPDouble *y,int n,IssmPDouble radius){
+void Observations::Distances(IssmPDouble* distances,IssmPDouble *x,IssmPDouble *y,int n,IssmPDouble radius){/*{{{*/
 
 	IssmPDouble xi,yi,obs;
@@ -187,6 +182,5 @@
 	}
 }/*}}}*/
-/*FUNCTION Observations::ObservationList(IssmPDouble **px,IssmPDouble **py,IssmPDouble **pobs,int* pnobs,IssmPDouble x_interp,IssmPDouble y_interp,IssmPDouble radius,int maxdata){{{*/
-void Observations::ObservationList(IssmPDouble **px,IssmPDouble **py,IssmPDouble **pobs,int* pnobs,IssmPDouble x_interp,IssmPDouble y_interp,IssmPDouble radius,int maxdata){
+void Observations::ObservationList(IssmPDouble **px,IssmPDouble **py,IssmPDouble **pobs,int* pnobs,IssmPDouble x_interp,IssmPDouble y_interp,IssmPDouble radius,int maxdata){/*{{{*/
 
 	/*Output and Intermediaries*/
@@ -270,6 +264,5 @@
 	*pnobs=nobs;
 }/*}}}*/
-/*FUNCTION Observations::ObservationList(IssmPDouble **px,IssmPDouble **py,IssmPDouble **pobs,int* pnobs){{{*/
-void Observations::ObservationList(IssmPDouble **px,IssmPDouble **py,IssmPDouble **pobs,int* pnobs){
+void Observations::ObservationList(IssmPDouble **px,IssmPDouble **py,IssmPDouble **pobs,int* pnobs){/*{{{*/
 
 	/*Output and Intermediaries*/
@@ -298,6 +291,5 @@
 	*pnobs=nobs;
 }/*}}}*/
-/*FUNCTION Observations::InterpolationIDW{{{*/
-void Observations::InterpolationIDW(IssmPDouble *pprediction,IssmPDouble x_interp,IssmPDouble y_interp,IssmPDouble radius,int mindata,int maxdata,IssmPDouble power){
+void Observations::InterpolationIDW(IssmPDouble *pprediction,IssmPDouble x_interp,IssmPDouble y_interp,IssmPDouble radius,int mindata,int maxdata,IssmPDouble power){/*{{{*/
 
 	/*Intermediaries*/
@@ -347,6 +339,5 @@
 	xDelete<IssmPDouble>(obs);
 }/*}}}*/
-/*FUNCTION Observations::InterpolationKriging{{{*/
-void Observations::InterpolationKriging(IssmPDouble *pprediction,IssmPDouble *perror,IssmPDouble x_interp,IssmPDouble y_interp,IssmPDouble radius,int mindata,int maxdata,Variogram* variogram){
+void Observations::InterpolationKriging(IssmPDouble *pprediction,IssmPDouble *perror,IssmPDouble x_interp,IssmPDouble y_interp,IssmPDouble radius,int mindata,int maxdata,Variogram* variogram){/*{{{*/
 
 	/*Intermediaries*/
@@ -424,6 +415,5 @@
 
 }/*}}}*/
-/*FUNCTION Observations::InterpolationNearestNeighbor{{{*/
-void Observations::InterpolationNearestNeighbor(IssmPDouble *pprediction,IssmPDouble x_interp,IssmPDouble y_interp,IssmPDouble radius){
+void Observations::InterpolationNearestNeighbor(IssmPDouble *pprediction,IssmPDouble x_interp,IssmPDouble y_interp,IssmPDouble radius){/*{{{*/
 
 	/*Intermediaries*/
@@ -436,6 +426,5 @@
 	*pprediction = obs;
 }/*}}}*/
-/*FUNCTION Observations::InterpolationV4{{{*/
-void Observations::InterpolationV4(IssmPDouble *pprediction,IssmPDouble x_interp,IssmPDouble y_interp,IssmPDouble radius,int mindata,int maxdata){
+void Observations::InterpolationV4(IssmPDouble *pprediction,IssmPDouble x_interp,IssmPDouble y_interp,IssmPDouble radius,int mindata,int maxdata){/*{{{*/
 	/* Reference:  David T. Sandwell, Biharmonic spline interpolation of GEOS-3
 	 * and SEASAT altimeter data, Geophysical Research Letters, 2, 139-142,
@@ -519,6 +508,5 @@
 	xDelete<IssmPDouble>(weights);
 }/*}}}*/
-/*FUNCTION Observations::QuadtreeColoring{{{*/
-void Observations::QuadtreeColoring(IssmPDouble* A,IssmPDouble *x,IssmPDouble *y,int n){
+void Observations::QuadtreeColoring(IssmPDouble* A,IssmPDouble *x,IssmPDouble *y,int n){/*{{{*/
 
 	int xi,yi,level;
@@ -531,6 +519,5 @@
 
 }/*}}}*/
-/*FUNCTION Observations::Variomap{{{*/
-void Observations::Variomap(IssmPDouble* gamma,IssmPDouble *x,int n){
+void Observations::Variomap(IssmPDouble* gamma,IssmPDouble *x,int n){/*{{{*/
 
 	/*Output and Intermediaries*/
Index: issm/trunk/src/c/classes/kriging/PowerVariogram.cpp
===================================================================
--- issm/trunk/src/c/classes/kriging/PowerVariogram.cpp	(revision 18081)
+++ issm/trunk/src/c/classes/kriging/PowerVariogram.cpp	(revision 18301)
@@ -13,6 +13,5 @@
 
 /*PowerVariogram constructors and destructor*/
-/*FUNCTION PowerVariogram::PowerVariogram(){{{*/
-PowerVariogram::PowerVariogram(){
+PowerVariogram::PowerVariogram(){/*{{{*/
 	this->nugget = 0.2;
 	this->slope  = 1.;
@@ -21,6 +20,5 @@
 }
 /*}}}*/
-/*FUNCTION PowerVariogram::PowerVariogram(Options* options){{{*/
-PowerVariogram::PowerVariogram(Options* options){
+PowerVariogram::PowerVariogram(Options* options){/*{{{*/
 
 	/*Defaults*/
@@ -39,6 +37,5 @@
 }
 /*}}}*/
-/*FUNCTION PowerVariogram::~PowerVariogram(){{{*/
-PowerVariogram::~PowerVariogram(){
+PowerVariogram::~PowerVariogram(){/*{{{*/
 	return;
 }
@@ -46,6 +43,5 @@
 
 /*Object virtual functions definitions:*/
-/*FUNCTION PowerVariogram::Echo {{{*/
-void PowerVariogram::Echo(void){
+void PowerVariogram::Echo(void){/*{{{*/
 	_printf_("PowerVariogram\n");
 	_printf_("   nugget: " << this->nugget << "\n");
@@ -54,8 +50,11 @@
 }
 /*}}}*/
+Object* PowerVariogram::copy(void){/*{{{*/
+	   return new PowerVariogram(*this);
+}
+/*}}}*/
 
 /*Variogram function*/
-/*FUNCTION PowerVariogram::Covariance{{{*/
-double PowerVariogram::Covariance(double deltax,double deltay){
+double PowerVariogram::Covariance(double deltax,double deltay){/*{{{*/
 	/*The covariance can be deduced from the variogram from the following
 	 * relationship:
@@ -74,6 +73,5 @@
 }
 /*}}}*/
-/*FUNCTION PowerVariogram::SemiVariogram{{{*/
-double PowerVariogram::SemiVariogram(double deltax,double deltay){
+double PowerVariogram::SemiVariogram(double deltax,double deltay){/*{{{*/
 	/*http://en.wikipedia.org/wiki/Variogram*/
 	double h,gamma;
Index: issm/trunk/src/c/classes/kriging/PowerVariogram.h
===================================================================
--- issm/trunk/src/c/classes/kriging/PowerVariogram.h	(revision 18081)
+++ issm/trunk/src/c/classes/kriging/PowerVariogram.h	(revision 18301)
@@ -26,5 +26,5 @@
 		int   Id(){_error_("Not implemented yet");}; 
 		int   ObjectEnum(){_error_("Not implemented yet");};
-		Object* copy(){_error_("Not implemented yet");};
+		Object* copy();
 
 		/*Variogram functions*/
